
USE SVH_REPORT_DB
GO

/*
|| Autor: Jhon Reyes
|| Fecha: 2022.07.18
|| Proyecto: JUNO
|| Proceso: Crea tabla que contiene el mapeo de la UR de SHV con la de Neinor		
*/

DECLARE @PERIODO_DATAMART VARCHAR(6);
SET @PERIODO_DATAMART = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);


--==========================================================================
--						Temporal Sociedades							
--==========================================================================

DROP TABLE IF EXISTS #TMP_SOCIEDADES

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO IN('KUTXABANK. PERIMETRO BANCOS', 'KUTXABANK. PERIMETRO INMOBILIARIA')
  AND FLAG = 1


--==========================================================================
--					Tabla Mapeo URs de SVH y Neinor
--     			INPUT PERIMETRO 1: DATOS_FUSION 							 
-- 				INPUT PERIMETRO 2: IND_ADJUDICADOS
--==========================================================================

DROP TABLE IF EXISTS #TMP_MAPEO_URS_DATOS_FUSION

SELECT 
		  FUSION.SOCIEDAD
		, FUSION.UNIDAD_REGISTRAL
		, UR.CONTROL_CARTERA
		, SOCIEDAD_ORIGEN_INI AS SOCIEDAD_KB
		, CAST(SOCIEDAD_ORIGEN_INI AS INT) USR003
		, FUSION.UR_ORIGEN_INI AS UNIDAD_REGISTRAL_KB
      , SUBSTRING(FUSION.NUM_UR_ANTIGUA,6,25) AS NUM_UR_ANTIGUA 
		, CASE WHEN TRY_CONVERT(INT, FUSION.UR_ORIGEN_INI) IS NULL THEN FUSION.UR_ORIGEN_INI ELSE CAST(TRY_CONVERT(INT, FUSION.UR_ORIGEN_INI) AS VARCHAR) END USR004
		, FUSION.PROMO_INI
		, UR.PROMOCION_COMERCIAL
		, UR.PROMOCION_CONJUNTA
		, UR.CODIGO_ACTUACION_BAJA
		, UR.DESC_CODIGO_ACTUACION_BAJA
		, 'DATOS_FUSION' ORIGEN
		, CAST(GETDATE() AS DATE) FECHA_CARGA
		INTO #TMP_MAPEO_URS_DATOS_FUSION
  FROM [SVH_CORP_DB].[DBO].[DATOS_FUSION] FUSION
  INNER JOIN #TMP_SOCIEDADES SOCIEDADES ON FUSION.SOCIEDAD = SOCIEDADES.SOCIEDAD 
  LEFT JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON FUSION.SOCIEDAD = UR.SOCIEDAD AND FUSION.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL AND UR.IND_MIGRACION = 'X'
  WHERE ISNULL(FUSION.UR_ORIGEN_INI,'') != ''

/*
|| IND_ADJUDICADOS.
|| Perímetro:
||		El perímetro son todos los registros generados desde A&A (desde mayo 2022 en adelante)
||		- SOCIEDAD y UNIDAD_REGISTRAL informados
|| Filtros:
||		Que el campo USR004 sea igual al ADJ317 (si son iguales significa que no se ha encontrado la ur origen en datos fusion)
||		y que el periodo sea diferente al actual
*/

DROP TABLE IF EXISTS #TMP_MAPEO_URS_IND_ADJUDICADOS

SELECT  
		  ADJ.SOCIEDAD
		, ADJ.UNIDAD_REGISTRAL
		, ADJ.CONTROL_CARTERA
		, '' SOCIEDAD_KB
		, CAST(ADJ.USR003 AS INT) USR003
		, '' UNIDAD_REGISTRAL_KB
        , '' NUM_UR_ANTIGUA
		, ADJ.USR004
		, '' PROMO_INI
		, '' PROMOCION_COMERCIAL
		, '' PROMOCION_CONJUNTA
		, '' CODIGO_ACTUACION_BAJA
		, '' DESC_CODIGO_ACTUACION_BAJA
		, 'INF_ADJUDICADOS' ORIGEN
		, CAST(GETDATE() AS DATE) FECHA_CARGA
		INTO #TMP_MAPEO_URS_IND_ADJUDICADOS
FROM JUNO.INF_ADJUDICADOS ADJ
WHERE ADJ.SOCIEDAD IS NOT NULL
AND ADJ.PERIODO = @PERIODO_DATAMART -1
AND ADJ.USR004 = ADJ.ADJ317
AND NOT EXISTS(SELECT 'X' FROM #TMP_MAPEO_URS_DATOS_FUSION WHERE SOCIEDAD = ADJ.SOCIEDAD AND UNIDAD_REGISTRAL = ADJ.UNIDAD_REGISTRAL)
AND (CASE WHEN @PERIODO_DATAMART = '202205' THEN '0' ELSE '1' END) = '1'


/* REVISAR ESTO

AÑADIR ESTOS CAMPOS, TANTO A LA TMP_IND_ADJUDICADOS, COMO A LA TABLA FINAL:
		, ADJ.ORIGEN INF_ADJ_ORIGEN
		, ADJ.PERIODO INF_ADJ_PERIODO
		, ADJ.CONTROL_CARTERA INF_ADJ_CONTROL_CARTERA

*/


INSERT INTO [JUNO].[TMP_MAPEO_URS]
SELECT Z.* 
FROM( 
	SELECT * FROM #TMP_MAPEO_URS_DATOS_FUSION
	UNION ALL
	SELECT * FROM #TMP_MAPEO_URS_IND_ADJUDICADOS
	)Z
WHERE NOT EXISTS (SELECT 'X' FROM [JUNO].[TMP_MAPEO_URS] MAPEO WHERE Z.SOCIEDAD = MAPEO.SOCIEDAD AND Z.UNIDAD_REGISTRAL = MAPEO.UNIDAD_REGISTRAL)	


